%% Copyright (C) 2023 Hongsheng Qi
%%
%% This program is free software: you can redistribute it and/or modify
%% it under the terms of the GNU General Public License as published by
%% the Free Software Foundation, either version 3 of the License, or
%% (at your option) any later version.
%%
%% This program is distributed in the hope that it will be useful,
%% but WITHOUT ANY WARRANTY; without even the implied warranty of
%% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%% GNU General Public License for more details.
%%
%% You should have received a copy of the GNU General Public License
%% along with this program.  If not, see <https://www.gnu.org/licenses/>.

%% -*- texinfo -*-
%% @deftypefn {} {@var{retval} =} dklb (@var{A}, @var{B})
%%
%% @seealso{}
%% @end deftypefn

%% $Id: dklb.m 37 2023-06-12 09:55:12Z qihs $

function retval = dklb (A, B)

% DKLB    Lie Braket for Dimension-Keeping Semi-Tensor Product (DKSTP)
	
if ~(isa(A,'sym') || isa(A,'double'))
	A = double(A);
end
if ~(isa(B,'sym') || isa(B,'double'))
	B = double(B);
end

if (ndims(A) > 2 || ndims(B) > 2)
	error('dklb: the input arguments must be 2-D.');
end
if ~(all(size(A) == size(B)))
    error('dklb: matrix dimensions must agree.');
end

retval = dksp(A,B) - dksp(B,A);

	
