function retval = lsp(a, b, varargin)

% LSP    (Left) Semi-tensor product for logical matrices, return an LM object
%
%   LSP(A,B) is to calculate the (left) semi-tensor product of two or more logical matrices.

% $Id: lsp.m 14 2013-01-14 14:45:44Z hsqi $

if nargin < 2
	error('Not enough input arguments.');
end

retval = lm;
a = lm(a);
b = lm(b);

retval = a*b;

if length(varargin) > 0
	for i = 1:length(varargin)
		retval = lsp(retval, lm(varargin{i}));
	end
end