function c = rightsp(a,b)
% RIGHTSP    Right Semi-Tensor Product of Matrices using Kronecker product
%
%   RIGHTSP(A,B) is to calculate the right semi-tensor product of A and B.

% $Id: rightsp.m 27 2016-04-13 14:42:58Z qihs $

if ~(isa(a,'sym') || isa(a,'double'))
    a = double(a);
end
if ~(isa(b,'sym') || isa(b,'double'))
    b = double(b);
end

if (ndims(a) > 2) || (ndims(b) > 2)
    error('Input arguments must be 2-D.');
end

n = size(a,2);
p = size(b,1);
if n == p
    c = a*b;
else
    t = lcm(n,p);
    c = kron(eye(t/n),a)*kron(eye(t/p),b);
end